//
//  UserDefaults.js
//  Kite
//
//  Created by Joe Rhodes
//  Copyright (c) 2015 Joe Rhodes. All rights reserved.
//


// -------------------------------------------------------------------------------------------
// Defaults Keys
// -------------------------------------------------------------------------------------------

var kExportTextLayersAsImages   = @"kite.export.exportTextLayersAsImages"
var kExportShapeLayersAsImages  = @"kite.export.exportShapeLayersAsImages"
var kFlattenLayersWithSuffix    = @"kite.export.flattenLayersWithSuffix"


// -------------------------------------------------------------------------------------------
// User Defaults Manager
// -------------------------------------------------------------------------------------------

UserDefaultsManager = function() {

    this.userDefaults = NSUserDefaults.standardUserDefaults()

    var defaults = NSDictionary.dictionaryWithObjects_forKeys_([true, true, true], [kExportTextLayersAsImages, kExportShapeLayersAsImages, kFlattenLayersWithSuffix])

    this.userDefaults.registerDefaults(defaults)
}

UserDefaultsManager.prototype = Object.create(Object.prototype, {

    exportTextLayersAsImages: {
        get: function() {
            return this.userDefaults.boolForKey(kExportTextLayersAsImages)
        },
        set: function(value) {
            this.userDefaults.setBool_forKey_(value, kExportTextLayersAsImages)
        }
    },

    exportShapeLayersAsImages: {
        get: function() {
            return this.userDefaults.boolForKey(kExportShapeLayersAsImages)
        },
        set: function(value) {
            this.userDefaults.setBool_forKey_(value, kExportShapeLayersAsImages)
        }
    },

    flattenLayersWithSuffix: {
        get: function() {
            return this.userDefaults.boolForKey(kFlattenLayersWithSuffix)
        },
        set: function(value) {
            this.userDefaults.setBool_forKey_(value, kFlattenLayersWithSuffix)
        }
    },
})

var UserDefaults = new UserDefaultsManager()